var dontSend = false;

function doSessionOnLoad() {
    this.onUsersChanged();
    if (typeof(window._MSG) != "undefined") { // From first incoming message
        var m = window._MSG;
        this.onMessageReceived(m[0], m[1], m[2], m[3]);
        delete window._MSG;
    }
    FontChanged();
    doTextSizeChange('small');
    document.getElementById('message').focus();
}

function doSessionOnUnLoad() {
    window._SESSION.exit();
    window.opener.client.unregisterSession(window._SESSION);
}

function doSendIM(e) {
    if ((e.type == 'command') || (e.type == 'keypress' && e.keyCode == 13)) {
        var msg = window.document.getElementById('message').value;
        if (msg == '') { return; }
        if (window._SESSION.ContactsCount() == 0) {
            msg = createNotifyNode(window.document, window._SESSION.bundle.GetStringFromName('noMembers'));
            appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
            return;
        }
        window.document.getElementById('message').value = '';
        window._SESSION.send(msg);
        msg = createMessageContentNode(window.document, msg, window._SESSION._CLIENT.MMS);
        var msg = createMessageNode(window.document, window._SESSION._CLIENT.Nickname, msg, true);
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
        e.preventBubble();
        return;
    }
    if (!dontSend) {
        if (window._SESSION.ContactsCount() == 0) {
            return;
        }
        dontSend = true;
        window._SESSION.sendTyping();
        setTimeout('dontSend = false', 4000);
    }
}

function doTextSizeChange(cls) {
    document.getElementById('chat-panel').contentDocument.body.setAttribute('class', cls);
    document.getElementById('message').setAttribute('class', cls);
}

window.onMessageReceived =
function onMessageReceived(from, fromEmail, headers, text) {
    if (headers['content-type'].substr(0, 10) == 'text/plain') {
        var textcontent = createMessageContentNode(window.document, text, headers['x-mms-im-format']);
        var msg = createMessageNode(window.document, from, textcontent);
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
        var con = null;
        con = window._SESSION.FindContact(fromEmail);
        con.timeout = 0;
        _updateSB();
    }
    else if (headers['content-type'].substr(0, 20) == 'text/x-msmsgscontrol') {
        var tu = headers['typinguser'];
        var con = null;
        con = window._SESSION.FindContact(tu);
        con.timeout = new Date().getTime();
        setTimeout('_updateSB()', 5000);
        _updateSB();
    }
    else if (headers['content-type'].substr(0, 19) == 'text/x-msmsgsinvite') {
        var h = new Array();
        var parts = text.split('\r\n');
        for (var i in parts) {
            var header = parts[i].split(": ");
            h[header[0]] = header[1];
        }

        if (h['Invitation-Command'] == 'INVITE')
            window._SESSION.cancelInvite(h['Invitation-Cookie'], "REJECT_NOT_INSTALLED");
        var msg = createNotifyNode(window.document, window._SESSION.bundle.GetStringFromName('InviteUnsupported'));
        appendAndScroll(window.document.getElementById('chat-panel').contentDocument, msg);
    }
}

window.onUsersChanged =
function onUsersChanged() {
    var value = '';
    for (var i in window._SESSION.Contacts) {
        var c = window._SESSION.Contacts[i];
        value += c.Nickname + ' <' + c.EMail + '>, ';
    }
    if (value == '') { value = window._SESSION.bundle.GetStringFromName('toNoOne') + '  ' };
    value = window._SESSION.bundle.GetStringFromName('sendMessageToLabel') + '  ' + value.substr(0, value.length - 2);
    var cp = window.document.getElementById('chat-participants')
    cp.firstChild.nodeValue = value;
}

window.FontChanged =
function FontChanged() {
    document.getElementById('message').setAttribute('style', window._SESSION._CLIENT.CSS);
}

function _updateSB() {
    var s = '';
    var count = 0;
    var t = new Date().getTime();
    for (var i in window._SESSION.Contacts) {
        var c = window._SESSION.Contacts[i];
        if (t <= c.timeout + 5000) {
            count++;
            s += c.Nickname + ', ';
        }
    }
    if (count == 0) {
        s = '';
    } else if (count == 1) {
        temp = window._SESSION.bundle.GetStringFromName('isTyping');
        s = temp.replace("%U", s.substr(0, s.length - 2));
    } else {
        temp = window._SESSION.bundle.GetStringFromName('areTyping');
        s = temp.replace("%U", s.substr(0, s.length - 2));
    }
    document.getElementById('status-bar-main').firstChild.setAttribute('label', s);
}